<template>
    <div>
        <el-row class="toolbar">
            <el-button type="primary" icon="el-icon-plus" size="mini" @click="formCreate()">
                Thêm mới
            </el-button>
        </el-row>

        <el-table :data="questions" border style="width: 100%">
            <el-table-column type="selection" width="55" align="center"></el-table-column>
            <el-table-column sortable prop="content" label="Nội dung câu hỏi">
            </el-table-column>
            <el-table-column width="150">
                <template slot-scope="scope">
                    <el-button size="mini" icon="el-icon-edit" @click="editQuestion(scope.row.id)"></el-button>
                    <el-button size="mini" icon="el-icon-delete" type="danger" @click="deleteQuestion(scope.row.id)"></el-button>
                </template>
            </el-table-column>
        </el-table>

        <el-row class="pagination-table-view">
            <el-pagination background layout="prev, pager, next"
                @current-change="changePage"
                :total="totalRecord">
            </el-pagination>
        </el-row>
    </div>
</template>

<script>
    export default {
        name: 'ListQuestionComponent',
        props: {},
        data() {
            return {
                questions: [],
                loading: false,
                totalRecord: 0,
                currentPage: 1,
                sort: 'column=id&sort=desc',
            }
        },
        created() {
            if (!localStorage.getItem('access_token')) {
                this.$router.push({name: 'login'});
            }

            this.getQuestions();
        },
        methods: {
            getQuestions() {
                this.loading = true;
                this.$axios.get(`api/v1/questions?page=${this.currentPage}&${this.sort}`).then((res) => {
                    if (res.status === 200) {
                        this.questions = res.data.questions;
                        this.totalRecord = res.data.meta.total;
                    }
                    this.loading = false;
                }).catch((errors) => {
                    this.loading = false;
                    this.$message({type: 'error',message: errors.message});
                });
            },
            changePage(page) {
                this.currentPage = page;
                this.getQuestions();
            },
            formCreate() {
                this.$router.push({name: 'questions.create'});
            },
            editQuestion(id) {
                this.$router.push({name: 'questions.edit',  params: {id: id}});
            },
            deleteQuestion(id) {
                this.$confirm('Bạn có chắc chắn xóa không?', 'Suntech', {
                    confirmButtonText: 'OK',
                    cancelButtonText: 'Cancel',
                    type: 'warning'
                }).then(() => {
                    this.$axios.delete(`api/v1/questions/${id}`).then((res) => {
                        if (res.status === 200) this.getQuestions();
                    }).catch((errors) => {
                        this.$message({type: 'error',message: errors.message});
                    });
                }).catch(() => {});
            }
        }
    }
</script>

<style>
    
</style>